﻿-- PLEASE READ --
-- PLEASE READ --
-- PLEASE READ --
--
-- Use ingame command "/nc" instead of manual editing list of cooldowns
--
--
local iconSize = 26;
local iconXOffset = 0;
local iconYOffset = 30;
local TrinketTex = "Interface\\Icons\\INV_Jewelry_TrinketPVP_01"; -- for the Horde tex replace with "Interface\\Icons\\INV_Jewelry_TrinketPVP_02"

local MainFrame = CreateFrame("Frame");
MainFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
MainFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");

NCEnabledCDs = {};
local Interrupts = {
	47528,	-- Mind Freeze
	80964,	-- Skull Bash (bear)
	80965,	-- Skull Bash (cat)
	34490,	-- Silencing Shot
	2139,	-- Counterspell
	96231,	-- Rebuke
	15487,	-- Silence
	1766,	-- Kick
	57994,	-- Wind Shear
	6552,	-- Pummel
	102060,	-- Disrupting Shout
	24259,	-- Spell Lock
	147362,	-- Counter Shot
	116705, -- Spear Hand Strike
};
local db = {};
local CDCache = {};
local CDsByTime = {
-- Misc
	[28730] = 120,				--"Arcane Torrent",
	[50613] = 120,				--"Arcane Torrent",
	[80483] = 120,				--"Arcane Torrent",
	[25046] = 120,				--"Arcane Torrent",
	[69179] = 120,				--"Arcane Torrent",
	[20572] = 120,				--"Blood Fury",
	[33702] = 120,				--"Blood Fury",
	[33697] = 120,				--"Blood Fury",
	[59543] = 180,				--"Gift of the Naaru",
	[69070] = 120,				--"Rocket Jump",
	[26297] = 180,				--"Berserking",
	[20594] = 120,				--"Stoneform",
	[58984] = 120,				--"Shadowmeld",
	[20589] = 90,				--"Escape Artist",
	[59752] = 120,				--"Every Man for Himself",
	[7744] = 120,				--"Will of the Forsaken",
	[68992] = 120,				--"Darkflight",
	[50613] = 120,				--"Arcane Torrent",
	[11876] = 120,				--"War Stomp",
	[69041] = 120,				--"Rocket Barrage",
	[42292] = 120,				--"PvP Trinket",
-- Pets(Hunter)
	[61685] = 25,				--"Charge",
	[50519] = 60,				--"Sonic Blast",
	[50245] = 40,				--"Pin",
	[50433] = 10,				--"Ankle Crack",
	[26090] = 30,				--"Pummel",
	[50541] = 60, 				--"Clench",
	[91644] = 60,				--"Snatch",
	[54706] = 40,				--"Vemom Web Spray",
	[4167] = 40,				--"Web",
	[50274] = 12,				--"Spore Cloud",
	[90355] = 360,				--"Ancient Hysteria",
	[90314] = 25,				--"Tailspin",
	[50318] = 60,				--"Serenity Dust",
	[90361] = 40,				--"Spirit Mend",
	[50285] = 40, 				--"Dust Cloud",
	[90327] = 40,				--"Lock Jaw",
	[90337] = 60,				--"Bad Manner",
	[55709] = 480,				--"Heart of the Phoenix",
	[53476] = 30,				--"Intervene",
	[53480] = 60,				--"Roar of Sacrifice",
	[53478] = 360,				--"Last Stand",
	[53517] = 180,				--"Roar of Recovery",
-- Pets(Warlock)
	[19647] = 24,				--"Spell Lock",
	[7812] = 60,				--"Sacrifice",
	[89766] = 30,				--"Axe Toss"
	[89751] = 45,				--"Felstorm",
	[115781] = 24,				-- Optical Blast
-- Pets(Mage)
	[33395] = 25,				--"Freeze", --No way to tell which WE cast this still usefull to some degree.
--Death Knight
	[47476] = 60,				--"Strangulate",
	[108194] = 30,				-- Asphyxiate
	[48707] = 45,				--"Anti-Magic Shell",
	[49576] = 25,				--"Death Grip",	
	[47528] = 13,				--"Mind Freeze",
	[108200] = 60,				--"Remorseless Winter",
	[108201] = 120,				--"Desecrated Ground",
	[108199] = 60,				--"Gorefiend's Grasp",
	[49039] = 120,				--"Lichborne",
	[49222] = 60,				--"Bone Shield",
	[51271] = 60,				--"Pillar of Frost",
	[51052] = 120,				--"Anti-Magic Zone",
	[49206] = 180,				--"Summon Gargoyle",
	[48792] = 180,				--"Icebound Fortitude",
	[48743] = 120,				--"Death Pact",
--Druid
	[78675] = 60,				--"Solar Beam",
	[5211] = 50,				--"Bash",
	[80964] = 15,				--"Skull Bash",
	[80965] = 15,				--"Skull Bash",
	[132469] = 30,				-- Тайфун
	[124974] = 90,				--"Nature's Vigil",
	[102359] = 30,				--"Mass Entanglement",
	[99] = 30,					--"Disorienting Roar",
	[102280] = 30,				--"Displacer Beast",
	[22812] = 60,				--"Barkskin",
	[132158] = 60,				--"Nature's Swiftness",
	[33891] = 180,				--"Tree of Life",
	[16979] = 15,				--"Wild Charge - Bear",
	[49376] = 15,				--"Wild Charge - Cat",
	[61336] = 180,				--"Survival Instincts",
	[50334] = 180,				--"Berserk",
	[22570] = 10,				--"Maim",
	[18562] = 15,				--"Swiftmend",
	[48505] = 90,				--"Starfall",
	[16689] = 60, 				--"Nature's Grasp",
	[740] = 480,				--"Tranquility",
	[78674] = 15,				--"Starsurge",
	[29166] = 180,				--"Innervate",	
--Hunter
	[19386] = 45,				--"Wyvern Sting",
	[19263] = 180,				--"Deterrence",
	[19503] = 30,				--"Scatter Shot",
	[34490] = 24,				--"Silencing Shot",
	[147362] = 24,				--"Counter Shot"
	[120697] = 90,				--"Lynx Rush",
	[120679] = 30,				--"Dire Beast",
	[109248] = 45,				--"Binding Shot",
	[1499] = 30,				--"Freezing Trap",
	[82726] = 30,				--"Fervor",
	[3045] = 180,				--"Rapid Fire",
	[53351] = 10,				--"Kill Shot",
	[53271] = 45, 				--"Master's Call",
	[51753] = 60,				--"Camouflage",
	[19574] = 60,				--"Bestial Wrath",
--Mage
	[2139] = 22,				--"Counterspell",
	[45438] = 300,				--"Ice Block",
	[110959] = 90,				--"Greater Invisibility",
	[102051] = 20,				--"Frostjaw",
	[44572] = 30,				--"Deep Freeze",
	[11958] = 180,				--"Cold Snap",	
	[12042] = 90,				--"Arcane Power",		
	[12051] = 120,				--"Evocation", 
	[122] = 25,					--"Frost Nova",	
	[11426] = 25,				--"Ice Barrier", 
	[12472] = 180,				--"Icy Veins",
	[55342] = 180,				--"Mirror Image", 
	[66] = 300,					--"Invisibility",
	[113724] = 45,				--"Ring of Frost",
	[80353] = 300, 				--"Time Warp",
	[12043] = 90,				--"Presence of Mind",
	[11129] = 45,				--"Combustion",
	[31661] = 20,				--"Dragon's Breath",
--Monk
	[116705] = 15, 				--Spear Hand Strike (interrupt)
	[115078] = 15, 				--Paralysis
	[119381] = 45, 				--Leg Sweep (mass stun)
	[123904] = 180,				--"Invoke Xuen, the White Tiger",
	[101643] = 45,				--"Transcendence",
	[119996] = 25,				--"Transcendence: Transfer",
	[115176] = 180,				--"Zen Meditation",
	[115310] = 180,				--"Revival",
	[122278] = 90, 				--"Dampen Harm",
	[122783] = 90,				--"Diffuse Magic",
	[117368] = 60,				--"Grapple Weapon",
	[116844] = 45,				--"Ring of Peace",
	[116849] = 120,				--"Life Cocoon",
	[137562] = 120,				--"Nimble Brew",
	[122470] = 90,				--"Touch of Karma",
	[101545] = 25,				--"Flying Serpent Kick",
	[116841] = 30,				--"Tiger's Lust",
	[113656] = 25,				--"Fists of Fury",
	[122057] = 35,				--"Clash",
--Paladin
	[853] = 60,					--"Hammer of Justice" (stun)
	[115750] = 120,				--Blinding Light (blind (sic!))
	[105593] = 30,				-- Fist of Justice
	[96231] = 15,				--"Rebuke",
	[642] = 300,				--"Divine Shield",
	[85499] = 45,				--"Speed of Light",
	[1044] = 25,				--"Hand of Freedom",
	[31884] = 180,				--"Avenging Wrath",
	[31935] = 15,				--"Avenger's Shield",
	[633] = 600,				--"Lay on Hands",
	[1022] = 300,				--"Hand of Protection",
	[498] = 60,					--"Divine Protection",
	[54428] = 120,				--"Divine Plea",
	[6940] = 120,				--"Hand of Sacrifice",
	[86669] = 180,				--"Guardian of Ancient Kings(Holy)",
	[31842] = 180,				--"Divine Favor",
	[31821] = 180,				--"Devotion Aura",
	[20066] = 15,				--"Repentance",
	[31850] = 180,				--"Ardent Defender",
--Priest
	[64044] = 45,				--"Psychic Horror",
	[8122] = 30,				--"Psychic Scream",
	[15487] = 45,				--"Silence",
	[47585] = 105,				--"Dispersion",
	[33206] = 180,				--"Pain Suppression",
	[108920] = 30,				-- Void Tendrils
	[108921] = 45,				-- Ментальный демон
	[112833] = 30,				-- Призрачный облик
	[123040] = 60,				--"Mindbender",
	[89485] = 45,				--"Inner Focus",@@@@@@@@@@@@@@@@@@@@@@@@
	[10060] = 120,				--"Power Infusion",
	[88625] = 30,				--"Holy Word: Chastise",
	[586] = 30,					--"Fade",
	[112833] = 30,				--"Spectral Guise",
	[6346] = 120,				--"Fear Ward",@@@@@@@@@@@@@@@@@@@@@@@@
	[64901] = 360,				--"Hymn of Hope",
	[64843] = 180,				--"Divine Hymn",
	[73325] = 90,				--"Leap of Faith",
	[19236] = 120,				--"Desperate Prayer",
	[724] = 180,				--"Lightwell",
	[62618] = 180,				--"Power Word: Barrier",
--Rogue
	[2094] = 90,				--"Blind",
	[1766] = 13,				--"Kick",
	[31224] = 60,				--"Cloak of Shadows",
	[1856] = 120,				-- Исчезновение
	[121471] = 180,				--"Shadow Blades",
	[1776] = 10,				--"Gouge",
	[2983] = 60,				--"Sprint",
	[14185] = 300,				--"Preparation",
	[36554] = 20,				--"Shadowstep",
	[5277] = 120,				--"Evasion",
	[408] = 20,					--"Kidney Shot",
	[51722] = 60,				--"Dismantle",
	[76577] = 180,				--"Smoke Bomb",
	[51690] = 120,				--"Killing Spree",
	[51713] = 60, 				--"Shadow Dance",
	[79140] = 120,				--"Vendetta",
--Shaman
	[8177] = 25,				--"Grounding Totem",
	[57994] = 12,				--"Wind Shear",
	[51490] = 35,				--"Thunderstorm",
	[51485] = 30,				--"Earthbind Totem",
	[8143] = 60,				--"Tremor Totem",
	[51514] = 35,				--"Hex",
	[108269] = 45,				--"Capacitor Totem",
	[108270] = 60,				--"Stone Bulwark Totem",
	[108280] = 180,				--"Healing Tide Totem",
	[98008] = 180,				--"Spirit Link Totem",
	[32182] = 300,				--"Heroism",
	[2825] = 300,				--"Bloodlust",
	[51533] = 120,				--"Feral Spirit",
	[16190] = 180,				--"Mana Tide Totem",
	[30823] = 60,				--"Shamanistic Rage",
	[2484] = 30,				--"Earthbind Totem",
	[79206] = 120,				--"Spiritwalker's Grace",
	[16166] = 90,				--"Elemental Mastery",
	[16188] = 90,				--"Ancestral Swiftness",
--Warlock
	[6789] = 45,				--"Death Coil",
	[5484] = 40,				--"Howl of Terror",
	[111397] = 30,				--"Blood Horror",
	[110913] = 180,				--"Dark Bargain",
	[108482] = 60,				--"Unbound Will",
	[108359] = 120,				--"Dark Regeneration",
	[108416] = 60,				--"Sacrificial Pact",
	[30283] = 30,				--"Shadowfury",
	[6229] = 30,				--"Shadow Ward",@@@@@@@@@@@@@@@@@@@@@@@@@
	[48020] = 30,				--"Demonic Circle: Teleport",
	[91711] = 30,				--"Nether Ward",
--Warrior
	[102060] = 40,				--"Разрушительный крик"
	[100] = 12,					--"Charge",
	[6552] = 15,				--"Pummel",
	[23920] = 20,				--"Spell Reflection",
	[46924] = 60,				--"Bladestorm",
	[46968] = 40,				--"Shockwave",
	[107574] = 180,				--"Avatar",
	[12292] = 60, 				--"Bloodbath",
	[86346] = 20,				--"Colossus Smash",
	[676] = 60,					--"Disarm",
	[5246] = 90,				--"Intimidating Shout",
	[871] = 180,				--"Shield Wall",	
	[118038] = 120,				--"Die by the Sword",
	[1719] = 180,				--"Recklessness",
	[3411] = 30,				--"Intervene",
	[64382] = 300,				--"Shattering Throw",
	[6544] = 30,				--"Heroic Leap", All Warriors use glyph de Death from above anyway@@@@@@@@@@@@@@@@@@@
	[12975] = 180,				--"Last Stand",
}
local CDsByClasses = {
	["Misc"] = { -- reviewed
		28730,				--"Arcane Torrent",
		50613,				--"Arcane Torrent",
		80483,				--"Arcane Torrent",
		25046,				--"Arcane Torrent",
		69179,				--"Arcane Torrent",
		20572,				--"Blood Fury",
		33702,				--"Blood Fury",
		33697,				--"Blood Fury",
		59543,				--"Gift of the Naaru",
		69070,				--"Rocket Jump",
		26297,				--"Berserking",
		20594,				--"Stoneform",
		58984,				--"Shadowmeld",
		20589,				--"Escape Artist",
		59752,				--"Every Man for Himself",
		7744,				--"Will of the Forsaken",
		68992,				--"Darkflight",
		50613,				--"Arcane Torrent",
		11876,				--"War Stomp",
		69041,				--"Rocket Barrage",
		42292,				--"PvP Trinket",
	},
	["Hunter"] = { -- reviewed
		19386,				--"Wyvern Sting",
		19263,				--"Deterrence",
		19503,				--"Scatter Shot",
		34490,				--"Silencing Shot",
		147362,				-- Встречный выстрел
		120697,				--"Lynx Rush",
		120679,				--"Dire Beast",
		109248,				--"Binding Shot",
		1499,				--"Freezing Trap",
		82726,				--"Fervor",
		3045,				--"Rapid Fire",
		53351,				--"Kill Shot",
		53271, 				--"Master's Call",
		51753,				--"Camouflage",
		19574,				--"Bestial Wrath",
	
		61685,				--"Charge",
		50519,				--"Sonic Blast",
		50245,				--"Pin",
		50433,				--"Ankle Crack",
		26090,				--"Pummel",
		50541, 				--"Clench",
		91644,				--"Snatch",
		54706,				--"Vemom Web Spray",
		4167,				--"Web",
		50274,				--"Spore Cloud",
		90355,				--"Ancient Hysteria",
		90314,				--"Tailspin",
		50318,				--"Serenity Dust",
		90361,				--"Spirit Mend",
		50285, 				--"Dust Cloud",
		90327,				--"Lock Jaw",
		90337,				--"Bad Manner",
		55709,				--"Heart of the Phoenix",
		53476,				--"Intervene",
		53480,				--"Roar of Sacrifice",
		53478,				--"Last Stand",
		53517,				--"Roar of Recovery",
	},
	["Warlock"] = { -- reviewed
		6789,				--"Death Coil",
		5484,				--"Howl of Terror",
		111397,				--"Blood Horror",
		110913,				--"Dark Bargain",
		108482,				--"Unbound Will",
		108359,				--"Dark Regeneration",
		108416,				--"Sacrificial Pact",
		30283,				--"Shadowfury",
		6229,				--"Shadow Ward",@@@@@@@@@@@@@@@@@@@@@@@@@
		48020,				--"Demonic Circle: Teleport",
		91711,				--"Nether Ward",
	
		19647,				--"Spell Lock",
		7812,				--"Sacrifice",
		89766,				--"Axe Toss"
		89751,				--"Felstorm",
		115781,				-- Optical Blast
	},
	["Mage"] = { -- reviewed
		2139,				--"Counterspell",
		45438,				--"Ice Block",
		110959,				--"Greater Invisibility",
		102051,				--"Frostjaw",
		44572,				--"Deep Freeze",
		11958,				--"Cold Snap",	
		12042,				--"Arcane Power",		
		12051,				--"Evocation", 
		122,				--"Frost Nova",	
		11426,				--"Ice Barrier", 
		12472,				--"Icy Veins",
		55342,				--"Mirror Image", 
		66,					--"Invisibility",
		113724,				--"Ring of Frost",
		80353, 				--"Time Warp",
		12043,				--"Presence of Mind",
		11129,				--"Combustion",
		31661,				--"Dragon's Breath",
	
		33395,				--"Freeze",
},
	["DK"] = { -- reviewed
		47476,				--"Strangulate",
		108194,				-- Asphyxiate
		48707,				--"Anti-Magic Shell",
		49576,				--"Death Grip",	
		47528,				--"Mind Freeze",
		108200,				--"Remorseless Winter",
		108201,				--"Desecrated Ground",
		108199,				--"Gorefiend's Grasp",
		49039,				--"Lichborne",
		49222,				--"Bone Shield",
		51271,				--"Pillar of Frost",
		51052,				--"Anti-Magic Zone",
		49206,				--"Summon Gargoyle",
		48792,				--"Icebound Fortitude",
		48743,				--"Death Pact",
	},
	["Druid"] = { -- reviewed
		78675,				--"Solar Beam",
		5211,				--"Bash",
		80964,				--"Skull Bash",
		80965,				--"Skull Bash",
		132469,				-- Тайфун
		124974,				--"Nature's Vigil",
		102359,				--"Mass Entanglement",
		99,					--"Disorienting Roar",
		102280,				--"Displacer Beast",
		22812,				--"Barkskin",
		132158,				--"Nature's Swiftness",
		33891,				--"Tree of Life",
		16979,				--"Wild Charge - Bear",
		49376,				--"Wild Charge - Cat",
		61336,				--"Survival Instincts",
		50334,				--"Berserk",
		22570,				--"Maim",
		18562,				--"Swiftmend",
		48505,				--"Starfall",
		16689, 				--"Nature's Grasp",
		740,				--"Tranquility",
		78674,				--"Starsurge",
		29166,				--"Innervate",
	},
	["Monk"] = {
		116705, 			--Spear Hand Strike (interrupt)
		115078, 			--Paralysis
		119381, 			--Leg Sweep (mass stun)
		
		123904,				--"Invoke Xuen, the White Tiger",
		101643,				--"Transcendence",
		119996,				--"Transcendence: Transfer",
		115176,				--"Zen Meditation",
		115310,				--"Revival",
		122278, 			--"Dampen Harm",
		122783,				--"Diffuse Magic",
		117368,				--"Grapple Weapon",
		116844,				--"Ring of Peace",
		116849,				--"Life Cocoon",
		137562,				--"Nimble Brew",
		122470,				--"Touch of Karma",
		101545,				--"Flying Serpent Kick",
		116841,				--"Tiger's Lust",
		113656,				--"Fists of Fury",
		122057,				--"Clash",
	},
	["Paladin"] = { -- reviewed
		853,				--"Hammer of Justice" (stun)
		115750,				--Blinding Light (blind (sic!))
		105593,				-- Fist of Justice
		96231,				--"Rebuke",
		642,				--"Divine Shield",
		85499,				--"Speed of Light",
		1044,				--"Hand of Freedom",
		31884,				--"Avenging Wrath",
		31935,				--"Avenger's Shield",
		633,				--"Lay on Hands",
		1022,				--"Hand of Protection",
		498,				--"Divine Protection",
		54428,				--"Divine Plea",
		6940,				--"Hand of Sacrifice",
		86669,				--"Guardian of Ancient Kings(Holy)",
		31842,				--"Divine Favor",
		31821,				--"Devotion Aura",
		20066,				--"Repentance",
		31850,				--"Ardent Defender",
	},
	["Priest"] = { -- reviewed
		64044,				--"Psychic Horror",
		8122,				--"Psychic Scream",
		15487,				--"Silence",
		47585,				--"Dispersion",
		33206,				--"Pain Suppression",
		108920,				-- Void Tendrils
		108921,				-- Ментальный демон
		112833,				-- Призрачный облик
		123040,				--"Mindbender",
		89485,				--"Inner Focus",@@@@@@@@@@@@@@@@@@@@@@@@
		10060,				--"Power Infusion",
		88625,				--"Holy Word: Chastise",
		586,				--"Fade",
		112833,				--"Spectral Guise",
		6346,				--"Fear Ward",@@@@@@@@@@@@@@@@@@@@@@@@
		64901,				--"Hymn of Hope",
		64843,				--"Divine Hymn",
		73325,				--"Leap of Faith",
		19236,				--"Desperate Prayer",
		724,				--"Lightwell",
		62618,				--"Power Word: Barrier",
	},
	["Rogue"] = { -- reviewed
		2094,				--"Blind",
		1766,				--"Kick",
		31224,				--"Cloak of Shadows",
		1856,				-- Исчезновение
		121471,				--"Shadow Blades",
		1776,				--"Gouge",
		2983,				--"Sprint",
		14185,				--"Preparation",
		36554,				--"Shadowstep",
		5277,				--"Evasion",
		408,					--"Kidney Shot",
		51722,				--"Dismantle",
		76577,				--"Smoke Bomb",
		51690,				--"Killing Spree",
		51713, 				--"Shadow Dance",
		79140,				--"Vendetta",
	},
	["Shaman"] = { -- reviewed
		8177,				--"Grounding Totem",
		57994,				--"Wind Shear",
		51490,				--"Thunderstorm",
		51485,				--"Earthbind Totem",
		8143,				--"Tremor Totem",
		51514,				--"Hex",
		108269,				--"Capacitor Totem",
		108270,				--"Stone Bulwark Totem",
		108280,				--"Healing Tide Totem",
		98008,				--"Spirit Link Totem",
		32182,				--"Heroism",
		2825,				--"Bloodlust",
		51533,				--"Feral Spirit",
		16190,				--"Mana Tide Totem",
		30823,				--"Shamanistic Rage",
		2484,				--"Earthbind Totem",
		79206,				--"Spiritwalker's Grace",
		16166,				--"Elemental Mastery",
		16188,				--"Ancestral Swiftness",
	},
	["Warrior"] = { -- reviewed
		102060,				--"Разрушительный крик"
		100,				--"Charge",
		6552,				--"Pummel",
		23920,				--"Spell Reflection",
		46924,				--"Bladestorm",
		46968,				--"Shockwave",
		107574,				--"Avatar",
		12292, 				--"Bloodbath",
		86346,				--"Colossus Smash",
		676,				--"Disarm",
		5246,				--"Intimidating Shout",
		871,				--"Shield Wall",	
		118038,				--"Die by the Sword",
		1719,				--"Recklessness",
		3411,				--"Intervene",
		64382,				--"Shattering Throw",
		6544,				--"Heroic Leap", All Warriors use glyph de Death from above anyway@@@@@@@@@@@@@@@@@@@
		12975,				--"Last Stand",
	},
};
local ElapsedTimer = 0;
local FirstPlayerEnteringWorldEvent = true;
local GUIFrame;
local fontSize = ceil(iconSize - iconSize / 2);
local _G = getfenv(0);

local OnStartup = OnStartup;
local OnUpdate = OnUpdate;
local OnPlayerEnteringWorld = OnPlayerEnteringWorld;
local OnCombatLogEventUnfiltered = OnCombatLogEventUnfiltered;
local ShowGUI = ShowGUI;
local InitializeGUI = InitializeGUI;
local Print = Print;
local CreateGUIButton = CreateGUIButton;
local OnGUICategoryClick = OnGUICategoryClick;
local CreateGUICategory = CreateGUICategory;
local ShowGUICategory = ShowGUICategory;
local tLength = tLength;
local RebuildCache = RebuildCache;
local AllocateIcon = AllocateIcon;

SLASH_NAMEPLATECOOLDOWNS1 = '/nc';
function SlashCmdList.NAMEPLATECOOLDOWNS(msg, editBox)
    ShowGUI();
end

function AllocateIcon(frame)
	local icon = CreateFrame("frame", nil, frame);
	icon:SetWidth(iconSize);
	icon:SetHeight(iconSize);
	icon.texture = icon:CreateTexture(nil, "BORDER");
	icon.texture:SetAllPoints(icon);
	icon.cooldown = icon:CreateFontString(nil, "OVERLAY");
	icon.cooldown:SetTextColor(0.7, 1, 0);
	icon.cooldown:SetAllPoints(icon);
	icon.cooldown:SetFont("Interface\\AddOns\\NameplateCooldowns\\teen_bold.ttf" , fontSize, "OUTLINE");
	icon.border = icon:CreateTexture(nil, "OVERLAY");
	icon.border:SetTexture("Interface\\AddOns\\NameplateCooldowns\\Border.tga");
	icon.border:SetVertexColor(1, 0.35, 0);
	icon.border:SetAllPoints(icon);
	icon:SetPoint("TOPLEFT", frame, iconXOffset + frame.axcount * iconSize, iconYOffset);
	icon:Hide();
	frame.axcount = frame.axcount + 1;
	table.insert(frame.axcooldowns, icon);
end

function OnStartup()
	for spellID in pairs(CDsByTime) do
		if (NCEnabledCDs[spellID] == nil) then
			NCEnabledCDs[spellID] = true;
		end
	end
	RebuildCache();
	MainFrame:SetScript("OnUpdate", function(self, elapsed)
		ElapsedTimer = ElapsedTimer + elapsed;
		if (ElapsedTimer >= 0.5) then
			OnUpdate();				
			ElapsedTimer = 0;
		end
	end);
end

function OnUpdate()
	local currentTime = GetTime();
	for i = 1, WorldFrame:GetNumChildren() do
		local f = select(i, WorldFrame:GetChildren());
		if (f:GetName()) then
			local nameplateFullName = f:GetName();
			if (nameplateFullName:find("NamePlate")) then
				if (f:IsVisible()) then
					local _, nameplateChild = f:GetChildren();
					local eman = nameplateChild:GetRegions();
					local name = gsub(eman:GetText(), '%s%(%*%)','');
					if (not f.axcooldowns) then
						f.axcooldowns = {};
						f.axcount = 0;
					end
					local count = 1;
					if (db[name]) then
						for index, value in pairs(db[name]) do
							if (count > f.axcount) then
								AllocateIcon(f);
							end
							local duration = CDCache[index];
							local last = currentTime - value;
							if (last < duration) then
								if (index == 42292) then
									f.axcooldowns[count].texture:SetTexture(TrinketTex);
								else
									local _, _, texture = GetSpellInfo(index);
									f.axcooldowns[count].texture:SetTexture(texture);
								end
								if (tContains(Interrupts, index)) then
									f.axcooldowns[count].border:Show();
								else
									f.axcooldowns[count].border:Hide();
								end
								local remain = duration - last;
								if (remain >= 60) then
									f.axcooldowns[count].cooldown:SetText(floor(remain/60).."m");
								else
									f.axcooldowns[count].cooldown:SetText(floor(remain));
								end
								f.axcooldowns[count]:Show();
								count = count + 1;
							end
						end
					end
					for k = count, f.axcount do
						f.axcooldowns[k]:Hide();
					end
				end
			end
		end
	end
end

function OnPlayerEnteringWorld()
	wipe(db);
end

function OnCombatLogEventUnfiltered(...)
	local _, eventType, _, _, srcName, srcFlags, _, _, _, _, _, spellID, spellName = ...;
	if (bit.band(srcFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) ~= 0) then
		if (CDCache[spellID]) then
			local Name = strmatch(srcName, "[%P]+")
			if (eventType == "SPELL_CAST_SUCCESS" or eventType == "SPELL_AURA_APPLIED" or eventType == "SPELL_MISSED" or eventType == "SPELL_SUMMON") then
				if (not db[Name]) then
					db[Name] = {};
				end
				if (spellID == 11958) then
					db[Name][45438] = 0; 	-- Ice Block
					db[Name][122] = 0;		-- Frost Nova
					db[Name][120] = 0;		-- Cone of Cold
				elseif (spellID == 14185) then
					db[Name][2983] = 0;		-- Sprint
					db[Name][1856] = 0;		-- Vanish
					db[Name][5277] = 0;		-- Evasion
					db[Name][51722] = 0;	-- Dismantle	
				end
				db[Name][spellID] = GetTime();
			end
		end
	end
end

function RebuildCache()
	wipe(CDCache);
	for spellID, enabled in pairs(NCEnabledCDs) do
		if (enabled == true and CDsByTime[spellID]) then
			CDCache[spellID] = CDsByTime[spellID];
		end
	end
end

function ShowGUI()
	if (not InCombatLockdown()) then
		if (not GUIFrame) then
			InitializeGUI();
		end
		GUIFrame:Show();
		OnGUICategoryClick(GUIFrame.CategoryButtons[1]);
	else
		Print("Options not available in combat!");
	end
end

function InitializeGUI()
	GUIFrame = CreateFrame("Frame", nil, UIParent);
	GUIFrame:SetHeight(300);
	GUIFrame:SetWidth(500);
	GUIFrame:SetPoint("CENTER", UIParent, "CENTER", 0, 80);
	GUIFrame:SetBackdrop({
		bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = 1,
		tileSize = 16,
		edgeSize = 16,
		insets = { left = 3, right = 3, top = 3, bottom = 3 } 
	});
	GUIFrame:SetBackdropColor(0.1,0.22,0.35,1);
	GUIFrame:SetBackdropBorderColor(0.1,0.1,0.1,1);
	GUIFrame:EnableMouse(1);
	GUIFrame:SetMovable(1);
	GUIFrame:SetFrameStrata("DIALOG");
	GUIFrame:SetToplevel(1);
	GUIFrame:SetClampedToScreen(1);
	GUIFrame:SetScript("OnMouseDown", function() GUIFrame:StartMoving(); end);
	GUIFrame:SetScript("OnMouseUp", function() GUIFrame:StopMovingOrSizing(); end);
	GUIFrame:Hide();
	
	GUIFrame.CategoryButtons = {};
	GUIFrame.ActiveCategory = 1;
	
	GUIFrame.header = GUIFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlight");
	GUIFrame.header:SetFont(GameFontNormal:GetFont(), 22, "THICKOUTLINE");
	GUIFrame.header:SetPoint("CENTER", GUIFrame, "CENTER", 0, 160);
	GUIFrame.header:SetText("NameplateCooldowns");
	
	GUIFrame.outline = CreateFrame("Frame", nil, GUIFrame);
	GUIFrame.outline:SetBackdrop({
		bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = 1,
		tileSize = 16,
		edgeSize = 16,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	});
	GUIFrame.outline:SetBackdropColor(0.1, 0.1, 0.2, 1);
	GUIFrame.outline:SetBackdropBorderColor(0.8, 0.8, 0.9, 0.4);
	GUIFrame.outline:SetPoint("TOPLEFT", 12, -12);
	GUIFrame.outline:SetPoint("BOTTOMLEFT", 12, 42);
	GUIFrame.outline:SetWidth(100);
	
	GUIFrame.CloseButton = CreateGUIButton(-11, -250, "Close", function() GUIFrame:Hide(); end);
	
	GUIFrame.TipText = GUIFrame:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	GUIFrame.TipText:SetFont("Fonts\\FRIZQT__.TTF", 14, nil);
	GUIFrame.TipText:SetPoint("LEFT", 125, 110);
	GUIFrame.TipText:SetText("Click on icon to enable/disable tracking:");
	
	for index, value in pairs({"Warrior", "Druid", "Priest", "Mage", "Monk", "Hunter", "Paladin", "Rogue", "DK", "Warlock", "Shaman", "Misc"}) do
		local b = CreateGUICategory();
		b.index = index;
		b.text:SetText(value);
		if (index == 1) then
			b:LockHighlight();
			b.text:SetTextColor(1, 1, 1);
			b:SetPoint("TOPLEFT", GUIFrame.outline, "TOPLEFT", 5, -6);
		else
			b:SetPoint("TOPLEFT",GUIFrame.outline,"TOPLEFT", 5, -18 * (index - 1) - 6);
		end
		
		local scrollArea = CreateFrame("ScrollFrame", "NCScrollPanel"..tostring(index), GUIFrame, "UIPanelScrollFrameTemplate");
		scrollArea:SetPoint("TOPLEFT", GUIFrame, "TOPLEFT", 110, -60);
		scrollArea:SetPoint("BOTTOMRIGHT", GUIFrame, "BOTTOMRIGHT", -30, 15);
		scrollArea:Hide();
		local parentpanel = CreateFrame("Frame", "NCScrollPanel"..value.."Parentpanel", scrollArea);
		scrollArea:SetScrollChild(parentpanel);
		parentpanel:SetPoint("CENTER", GUIFrame, "CENTER", 0, 1);
		parentpanel:SetWidth(288);
		parentpanel:SetHeight(288);
		
		local iterator = 1;
		for _, k in pairs(CDsByClasses[value]) do
			local n, _, icon = GetSpellInfo(k);
			if (not n) then
				Print("Unknown spell: "..k);
			end
			
			local spellItem = CreateFrame("button", nil, parentpanel, "SecureActionButtonTemplate");
			spellItem:SetHeight(20);
			spellItem:SetWidth(20);
			spellItem:SetPoint("TOPLEFT", 3, ((iterator - 1) * -22) - 10);
			
			spellItem.tex = spellItem:CreateTexture();
			spellItem.tex:SetAllPoints(spellItem);
			spellItem.tex:SetHeight(20);
			spellItem.tex:SetWidth(20);
			spellItem.tex:SetTexture(icon);
			
			spellItem.Text = spellItem:CreateFontString(nil, "OVERLAY");
			spellItem.Text:SetFont("Fonts\\FRIZQT__.TTF", 12, nil);
			spellItem.Text:SetPoint("LEFT", 22, 0);
			spellItem.Text:SetText(n.."  (ID: "..tostring(k)..")");
			spellItem:EnableMouse(true);
			
			spellItem:SetScript("OnEnter", function(self, ...)
				GameTooltip:SetOwner(spellItem, "ANCHOR_TOPRIGHT");
				GameTooltip:SetSpellByID(k);
				GameTooltip:Show();
			end)
			spellItem:SetScript("OnLeave", function(self, ...)
				GameTooltip:Hide();
			end)
			spellItem:SetScript("OnClick", function(self, ...)
				if (self.tex:GetAlpha() > 0.5) then
					NCEnabledCDs[k] = false;
					self.tex:SetAlpha(0.3);
				else
					NCEnabledCDs[k] = true;
					self.tex:SetAlpha(1.0);
				end
				RebuildCache();
			end)
			if (NCEnabledCDs[k] == true) then
				spellItem.tex:SetAlpha(1.0);
			else
				spellItem.tex:SetAlpha(0.3);
			end
			iterator = iterator + 1;
		end
	end
end

function OnGUICategoryClick(self, ...)
	GUIFrame.CategoryButtons[GUIFrame.ActiveCategory].text:SetTextColor(1, 0.82, 0);
	GUIFrame.CategoryButtons[GUIFrame.ActiveCategory]:UnlockHighlight();
	GUIFrame.ActiveCategory = self.index;
	self.text:SetTextColor(1, 1, 1);
	self:LockHighlight();
	PlaySound("igMainMenuOptionCheckBoxOn");
	ShowGUICategory(GUIFrame.ActiveCategory);
end

function ShowGUICategory(index)
	for i = 1, 12 do
		_G["NCScrollPanel"..tostring(i)]:Hide();
	end
	_G["NCScrollPanel"..tostring(index)]:Show();
end

function CreateGUICategory()
	local b = CreateFrame("Button", nil, GUIFrame.outline);
	b:SetWidth(92);
	b:SetHeight(18);
	b:SetScript("OnClick", OnGUICategoryClick);
	b:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight");
	b:GetHighlightTexture():SetAlpha(0.7);
	b.text = b:CreateFontString(nil, "ARTWORK", "GameFontNormal");
	b.text:SetPoint("LEFT", 3, 0);
	GUIFrame.CategoryButtons[#GUIFrame.CategoryButtons + 1] = b;
	return b;
end

function CreateGUIButton(x, y, text, func)
	local btn = CreateFrame("Button", nil, GUIFrame.outline, "UIPanelButtonTemplate");
	btn:SetWidth(80);
	btn:SetHeight(24);
	btn:SetPoint("TOPRIGHT", x, y);
	btn:SetScript("OnClick", func);
	btn:SetText(text);
	return btn;
end

function Print(message)
	print("|c50C41F3BNameplateCooldowns: "..message.."|r");
end

function tLength(t)
	local count = 0;
	for _, v in pairs(t) do
		count = count + 1;
	end
	return count;
end

MainFrame:SetScript("OnEvent", function(self, event, ...)
	if (event == "PLAYER_ENTERING_WORLD") then
		if (FirstPlayerEnteringWorldEvent == true) then
			OnStartup();
			FirstPlayerEnteringWorldEvent = false;
		end
		OnPlayerEnteringWorld();
	else
		OnCombatLogEventUnfiltered(...);
	end
end);